#
# spec file for package openssl (Version 0.9.6b)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  -ssleay autoconf automake bc libtool perl
# usedforbuild    -ssleay aaa_base aaa_dir autoconf automake base bash bc bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         openssl
%define num_version %(echo "%{version}" | sed -e "s+[a-zA-Z]++g")
Copyright:    1998-2001 The OpenSSL Project
Group:        Utilities/System
Provides:     ssl
Conflicts:    ssleay
Obsoletes:    ssleay
Autoreqprov:  on
Version:      0.9.6b
Release:      62
Summary:      Secure Sockets and Transport Layer Security
URL:          http://www.%{name}.org/
Source:       http://www.%{name}.org/source/%{name}-engine-%{version}.tar.bz2
Patch0:       %{name}-%{version}.dif
BuildRoot:    %{_tmppath}/%{name}-%{version}-%{release}

%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, full-featured, and Open Source toolkit implementing
the Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS
v1) protocols with full-strength cryptography world-wide. The project
is managed by a worldwide community of volunteers that use the
Internet to communicate, plan, and develop the OpenSSL toolkit and its
related documentation.
Derivation and License
OpenSSL is based on the excellent SSLeay library developed from Eric
A. Young and Tim J. Hudson. The OpenSSL toolkit is licensed under a
Apache-style licence which basically means that you are free to get
and use it for commercial and non-commercial purposes.

Authors:
--------
    Mark J. Cox <mark@openssl.org>
    Ralf S. Engelschall <rse@openssl.org>
    Dr. Stephen Henson <steve@openssl.org>
    Ben Laurie <ben@openssl.org>
    Bodo Moeller <bodo@openssl.org>
    Ulf Moeller <ulf@openssl.org>
    Holger Reif <holger@openssl.org>
    Paul C. Sutton <paul@openssl.org>

SuSE series: sec

%package devel
Summary:      The OpenSSL source tree
Group:        Utilities/System
Obsoletes:    openssls

%description devel
This package containes the OpenSSL source tree, header files and
static libraries.

Authors:
--------
    Mark J. Cox <mark@openssl.org>
    Ralf S. Engelschall <rse@openssl.org>
    Dr. Stephen <Henson steve@openssl.org>
    Ben Laurie <ben@openssl.org>
    Bodo Moeller <bodo@openssl.org>
    Ulf Moeller <ulf@openssl.org>
    Holger Reif <holger@openssl.org>
    Paul C. Sutton <paul@openssl.org>

SuSE series: d

%package doc
Summary:      documentation and examples for OpenSSL
Group:        Utilities/System

%description doc
This package contains the documentation and examples for OpenSSL.

Authors:
--------
    Mark J. Cox <mark@openssl.org>
    Ralf S. Engelschall <rse@openssl.org>
    Dr. Stephen <Henson steve@openssl.org>
    Ben Laurie <ben@openssl.org>
    Bodo Moeller <bodo@openssl.org>
    Ulf Moeller <ulf@openssl.org>
    Holger Reif <holger@openssl.org>
    Paul C. Sutton <paul@openssl.org>

SuSE series: doc

%package src
Summary:      configured source code
Group:        Utilities/System

%description src
This package contains the preconfigured source code of openssl. This
cannot be provided by a SRPM, so we created a separate package for
it. You basically will never need this, so dont install unless you
are compiling a package yourself which requires this.

SuSE series: suse

%prep
%setup -n %{name}-engine-%{version}
%patch -p1
#
# replace wrong location of perl
#
for file in `find . -type f -exec fgrep -l /local/bin/perl {} \;`; do
    cat $file | \
    sed -e 's+/user/local/bin/perl+%{_bindir}/perl+' \
	-e 's+/usr/local/bin/perl+%{_bindir}/perl+' > tmp_file;
    mv tmp_file $file;
done

%build
./config threads no-rc5 no-idea --prefix=%{_prefix} --openssldir=%{_datadir}/ssl $RPM_OPT_FLAGS -fPIC shared
perl util/perlpath.pl %{_bindir}/perl
# 
# install now before objects are being compiled
#
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
mkdir -p $RPM_BUILD_ROOT/%{_libdir}
mkdir -p $RPM_BUILD_ROOT/%{_includedir}
mkdir -p $RPM_BUILD_ROOT/%{_usrsrc}
mkdir -p $RPM_BUILD_ROOT/%{_mandir}
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_usrsrc}/%{name}-%{version}
cp -a .  $RPM_BUILD_ROOT/%{_usrsrc}/%{name}-%{version}
make
%ifarch ppc s390 s390x sparc sparc64
make do_linux-shared
%endif
make rehash LD_LIBRARY_PATH=`pwd`
make test LD_LIBRARY_PATH=`pwd`

%install
make MANDIR=%{_mandir} INSTALL_PREFIX=$RPM_BUILD_ROOT install
for file in `find . -maxdepth 1 -type f -name lib\*.so.\* -o -name lib\*.a` ; do
	install -m755 $file $RPM_BUILD_ROOT/%{_libdir}
done
cp -pr certs/* $RPM_BUILD_ROOT/%{_datadir}/ssl/certs
#
# check wether a shared library has been installed
#
test -f $RPM_BUILD_ROOT/%{_libdir}/libssl.so.%{num_version} || exit 1
%ifarch ppc s390 s390x sparc sparc64
pushd $RPM_BUILD_ROOT/%{_libdir}
 ln -s libcrypto.so.* libcrypto.so
 ln -s libssl.so.*    libssl.so
popd
%endif
ldconfig -l $RPM_BUILD_ROOT/%{_libdir}/libcrypto.so.*
ldconfig -l $RPM_BUILD_ROOT/%{_libdir}/libssl.so.*
ln -sf ./%{name} $RPM_BUILD_ROOT/%{_includedir}/ssl
mv $RPM_BUILD_ROOT/%{_mandir}/man1/passwd.1 $RPM_BUILD_ROOT/%{_mandir}/man1/sslpasswd.1
mv $RPM_BUILD_ROOT/%{_mandir}/man3/rand.3   $RPM_BUILD_ROOT/%{_mandir}/man3/sslrand.3
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}
cat > showciphers.c <<EOF
#include <openssl/err.h>
#include <openssl/ssl.h>
main(){
unsigned int i;
SSL_CTX *ctx;
SSL *ssl;
SSL_METHOD *meth;
  meth = SSLv2_client_method();
  SSLeay_add_ssl_algorithms();
  ctx = SSL_CTX_new(meth);
  if (ctx == NULL) return 0;
  ssl = SSL_new(ctx);
  if (!ssl) return 0;
  for (i=0; ; i++) {
    int j, k;
    SSL_CIPHER *sc;
    sc = (meth->get_cipher)(i);
    if (!sc) break;
    k = SSL_CIPHER_get_bits(sc, &j);
    printf("%s\n", sc->name);
  }
};
EOF
gcc $RPM_OPT_FLAGS -I${RPM_BUILD_ROOT}%{_includedir} -c showciphers.c
gcc -o showciphers showciphers.o -L${RPM_BUILD_ROOT}%{_libdir} -lssl -lcrypto
LD_LIBRARY_PATH=${RPM_BUILD_ROOT}%{_libdir} ./showciphers > AVAILABLE_CIPHERS
cat AVAILABLE_CIPHERS

%clean
make clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files devel
%defattr(-, root, root)
%{_includedir}/%{name}/
%{_includedir}/ssl
%{_libdir}/libcrypto.a
%{_libdir}/libssl.a
%{_libdir}/libRSAglue.a
%{_libdir}/libcrypto.so
%{_libdir}/libssl.so

%files src
%defattr(-, root, root)
%{_usrsrc}/%{name}-%{version}

%files doc
%defattr(-, root, root)
%doc doc/* demos
%doc showciphers showciphers.c 
%doc %{_mandir}/man*/*

%files
%defattr(-, root, root)
%doc CHANGE* INSTAL* AVAILABLE_CIPHERS
%doc LICENSE NEWS README README.SuSE openssl.doxy
%doc %{_mandir}/man1/openssl.1.gz
%{_datadir}/ssl
%{_bindir}/c_rehash
%{_bindir}/%{name}
%{_libdir}/libcrypto.so.*
%{_libdir}/libssl.so.*

%changelog -n openssl
* Fri Aug 31 2001 - rolf@suse.de
- added root certificates [BUG#9913]
- move from /usr/ssh to /usr/share/ssl
* Wed Jul 18 2001 - rolf@suse.de
- update to 0.9.6b
- switch to engine version of openssl, which supports hardware
  encryption for a few popular devices
- check wether shared libraries have been generated
* Thu Jul 05 2001 - rolf@suse.de
- appliy PRNG security patch
* Tue Jun 12 2001 - bk@suse.de
- added support for s390x
* Mon May 07 2001 - kukuk@suse.de
- Fix building of shared libraries on SPARC, too.
* Mon May 07 2001 - rolf@suse.de
- Fix ppc and s390 shared library builds
- resolved conflict in manpage naming:
  rand.3 is now sslrand.3 [BUG#7643]
* Tue May 01 2001 - schwab@suse.de
- Fix ia64 configuration.
- Fix link command.
* Thu Apr 26 2001 - bjacke@suse.de
- updated to 0.96a
* Wed Apr 18 2001 - kkaempf@suse.de
- provide .so files in -devel package only
* Tue Apr 17 2001 - bjacke@suse.de
- resolve file name conflict (#6966)
* Wed Mar 21 2001 - rolf@suse.de
- new subpackage openssl-src [BUG#6383]
- added README.SuSE which explains where to find the man pages [BUG#6717]
* Fri Dec 15 2000 - sf@suse.de
- changed CFLAG to -O1 to make the tests run successfully
* Mon Dec 11 2000 - rolf@suse.de
- build openssl with no-idea and no-rc5 to meet US & RSA regulations
- build with -fPIC on all platforms (especially IA64)
* Wed Nov 22 2000 - rolf@suse.de
- rename openssls to openssl-devel and add shared libs and header files
- new subpackge openssl-doc for manpages and documentation
- use BuildRoot
* Fri Oct 27 2000 - schwab@suse.de
- Add link-time links for libcrypto and libssl.
- Make sure that LD_LIBRARY_PATH is passed down to sub-makes.
* Mon Oct 02 2000 - rolf@suse.de
- update to 0.9.6
* Mon Apr 10 2000 - bk@suse.de
- fix support for s390-linux
* Mon Apr 10 2000 - rolf@suse.de
- new version 0.9.5a
* Sun Apr 09 2000 - bk@suse.de
- add support for s390-linux
* Mon Mar 27 2000 - kukuk@suse.de
- Use sparcv7 for SPARC
* Wed Mar 01 2000 - rolf@suse.de
- move manpages back, as too many conflict with system manuals
* Wed Mar 01 2000 - rolf@suse.de
- move manpages to %%{_mandir}
- include static libraries
* Wed Mar 01 2000 - bk@suse.de
- added subpackage source openssls, needed for ppp_ssl
* Tue Feb 29 2000 - rolf@suse.de
- new version 0.9.5
* Thu Feb 24 2000 - schwab@suse.de
- add support for ia64-linux
* Mon Jan 31 2000 - kukuk@suse.de
- Create and add libcrypto.so.0 and libssl.so.0
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Wed Sep 01 1999 - rolf@suse.de
- new version 0.9.4
* Wed May 26 1999 - rolf@suse.de
- new version 0.9.3 with new layout
- alpha asm disabled by default now, no patch needed
* Thu May 20 1999 - ro@suse.de
- disable asm for alpha: seems incomplete
* Mon May 17 1999 - rolf@suse.de
- don't use -DNO_IDEA
* Wed May 12 1999 - rolf@suse.de
- first version 0.9.2b
